------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2010 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3731 $ $Date: 2010-04-30 13:21:13 +0400 (Fri, 30 Apr 2010) $
------------------------------------------------------------------------------
pragma Style_Checks ("NM32766");
with System.Address_To_Access_Conversions;

package body Qt4.List_Of_Q_Byte_Arrays is

   function initialize_QListOfQByteArray
    (Storage : System.Address)
      return Internals.QListOfQByteArray_Access;
   pragma Import (C, initialize_QListOfQByteArray, "__QtAda_inititialize_QListOfQByteArray");

   function adjust_QListOfQByteArray
    (Storage : System.Address;
     From    : Internals.QListOfQByteArray_Access)
       return Internals.QListOfQByteArray_Access;
   pragma Import (C, adjust_QListOfQByteArray, "__QtAda_adjust_QListOfQByteArray");

   procedure finalize_QListOfQByteArray (Object : Internals.QListOfQByteArray_Access);
   pragma Import (C, finalize_QListOfQByteArray, "__QtAda_finalize_QListOfQByteArray");

   ------------
   -- Adjust --
   ------------

   overriding
   procedure Adjust (Self : in out Q_List_Of_Q_Byte_Array) is
   begin
      Self.Object := adjust_QListOfQByteArray (Self.Storage'Address, Self.Object);
      Self.Wrapper := False;
   end Adjust;

   --------------
   -- Finalize --
   --------------

   overriding
   procedure Finalize (Self : in out Q_List_Of_Q_Byte_Array) is
   begin
      if not Self.Wrapper then
         finalize_QListOfQByteArray (Self.Object);
      end if;
   end Finalize;

   ----------------
   -- Initialize --
   ----------------

   overriding
   procedure Initialize (Self : in out Q_List_Of_Q_Byte_Array) is
      use type Internals.QListOfQByteArray_Access;

   begin
      if Self.Object = null then
         Self.Object := initialize_QListOfQByteArray (Self.Storage'Address);
      end if;
   end Initialize;

   ---------------
   -- Internals --
   ---------------

   package body Internals is

   ----------------------------
   -- QListOfQByteArray_View --
   ----------------------------

      function QListOfQByteArray_View
       (Item : Q_List_Of_Q_Byte_Array'Class)
          return QListOfQByteArray_Access
      is
      begin
         return Item.Object;
      end QListOfQByteArray_View;

      package QListOfQByteArray_Conversions is
        new System.Address_To_Access_Conversions
             (QListOfQByteArray);

   ---------------------------------
   -- QListOfQByteArrayTo_Pointer --
   ---------------------------------

      function To_Pointer
       (Address : System.Address)
          return QListOfQByteArray_Access
      is
      begin
         return
           QListOfQByteArray_Access
            (QListOfQByteArray_Conversions.To_Pointer
            (Address));
      end To_Pointer;

   ---------------------------------
   -- QListOfQByteArrayTo_Address --
   ---------------------------------

      function To_Address
       (Pointer : QListOfQByteArray_Access)
          return System.Address
      is
      begin
         return
           QListOfQByteArray_Conversions.To_Address
            (QListOfQByteArray_Conversions.Object_Pointer
              (Pointer));
      end To_Address;

   --------------------
   -- Create_Wrapper --
   --------------------

      function Create_Wrapper
       (Item : Internals.QListOfQByteArray_Access)
          return Q_List_Of_Q_Byte_Array
      is
      begin
         return Q_List_Of_Q_Byte_Array'
          (Ada.Finalization.Controlled with
             Object  => Item,
             Wrapper => True,
             others  => <>);
      end Create_Wrapper;

   end Internals;

end Qt4.List_Of_Q_Byte_Arrays;
